#!/usr/bin/perl
use Authen::PAM;

sub my_conv_func {
  my @res;
	while ( @_ ) {
		my $code = shift;
		my $msg = shift;
		my $ans = "";

		if ($msg=~/.*current.*password/) {
			$ans=$pam_password;
		} elsif ($msg=~/.*ew.*password/) {
			$ans=$pam_newpassword;
		} else {
			$ans='';
		}
		$debugans=$ans;
		$debugans=~s/./\*/g;
		push @res, PAM_SUCCESS();
		push @res, $ans;
		print("$msg $debugans\n");
	}
	push @res, PAM_SUCCESS();
	return @res;
}


  $pam_username = shift;
  $pam_password = shift;
	$pam_newpassword = shift;
	$pam_state=0;

  local $pamh = new Authen::PAM('passwd', $pam_username,\&my_conv_func);
  if (!ref($pamh)) {
    return 0;
  }
  local $pam_ret = $pamh->pam_chauthtok;
	print("result=$pam_ret; ".$pamh->pam_strerror($pam_ret)."\n");
	if ($pam_ret==0) {
		# Authentication Ok, password changed
		print("Password unix cambiata correttamente!\nInoltro richiesta modifica password per accesso alle condivisioni... (sar attivata in pochi minuti)\n");
		print("Esecuzione CORRETTA\n");
	} else {
		print("La vecchia password risulta sbagliata, oppure la nuova risulta non adeguata:\n   (utilizzare almeno 6 caratteri contenenti maiuscole, minuscole e numeri!)\n");
		print("Esecuzione ERRATA\n");
	}

#  ref($pamh = new Authen::PAM($service, $username, \&my_conv_func)) ||
#         die "Error code $pamh during PAM init!";

#  $state = 0;
#  $res = $pamh->pam_chauthtok;
#  print $pamh->pam_strerror($res),"\n" unless $res == PAM_SUCCESS();
